#include <bits/stdc++.h>

using namespace std;

int main()
{
    long int n,nt = 0,k,num = 1;
    bool btemp = false;

    cin >> n;
    cin >> k;

    long int niz[n];

    for(int i = 0; i < n; ++i) {
        cin >> niz[i];
    }

    sort(niz, niz + n);
    cout << endl;

    for(int i = 0; i < n - 1; ++i) {
        if(niz[i] != niz[i+1]) {
            btemp = false;
        } else {
            btemp = true;
        }

        if(btemp == false && num >= k) {
            cout << niz[i] << " ";
        }

        if(niz[i] != niz[i+1]) {
            num = 1;
        } else {
            num++;
        }
    }

    if(num >= k) {
        cout << niz[n-1];
    }

    return 0;
}